                     /* +---------------------+
                        |  Calcul d'un pixel  |
                        +---------------------+ */

#include "caml/mlvalues.h"

value pixel(value *argv)
{
  double u  = Double_val(argv[0]),  v  = Double_val(argv[1]);
  double jx = Double_val(argv[2]),  jy = Double_val(argv[3]);
  double u2 = u*u, v2   = v*v;
  int    n  = 0,   nmax = Int_val(argv[4]);

  while ((u2+v2 < 4.0) && (n < nmax)) {
    v  = 2.0*u*v + jy;
    u  = u2 - v2 + jx;
    u2 = u*u;
    v2 = v*v;
    n++;
  }

  return(Val_int((n*(Int_val(argv[5])-1))/nmax));
}
		   
